﻿function GetPluginSettings()
{
    return {
        "name": "ZarinPal",
        "id": "Vinoos_ZarinPal",
        "version": "1.0.0",
        "description": "ZarinPal InApp Purchase",
        "author": "Vinoos",
        "help url": "http://vinoos.ir/plugins/zarinpal.php",
        "category": "Vinoos",
        "type": "object",
        "rotatable": false,
        "cordova-plugins": "https://github.com/vinoosir/cordova-plugin-zarinpal",
        "flags": 0 | pf_singleglobal
    };
};

////////////////////////////////////////
// Conditions
AddNumberParam("شناسه", "شناسه پرداخت");
AddCondition(0, cf_trigger, "اگر شروع پرداخت انجام شد", "ZarinPal", "اگر شروع پرداخت با شناسه {0} انجام شد", "اگر شروع پرداخت انجام شد", "onStartPaymentSuccess");
AddNumberParam("شناسه", "شناسه پرداخت");
AddCondition(1, cf_trigger, "اگر شروع پرداخت انجام نشد", "ZarinPal", "اگر شروع پرداخت با شناسه {0} انجام نشد", "اگر شروع پرداخت انجام نشد", "onStartPaymentFailed");
AddNumberParam("شناسه", "شناسه پرداخت");
AddCondition(2, cf_trigger, "اگر پرداخت انجام شد", "ZarinPal", "اگر پرداخت با شناسه {0} انجام شد", "اگر پرداخت انجام شد", "onPaymentSuccess");
AddNumberParam("شناسه", "شناسه پرداخت");
AddCondition(3, cf_trigger, "اگر پرداخت انجام نشد", "ZarinPal", "اگر پرداخت با شناسه {0} انجام نشد", "اگر پرداخت انجام نشد", "onPaymentFailed");
AddNumberParam("شناسه", "شناسه پرداخت");
AddCondition(4, cf_trigger, "اگر نمایش صفحه پرداخت انجام نشد", "ZarinPal", "اگر نمایش صفحه پرداخت با شناسه {0} انجام نشد", "اگر نمایش صفحه پرداخت انجام نشد", "onShowPaymentFailed");

////////////////////////////////////////
// Actions
AddNumberParam("شناسه", "شناسه پرداخت");
AddComboParamOption("غیرفعال");
AddComboParamOption("فعال");
AddComboParam("نمایش خودکار", "نمایش خودکار صفحه پرداخت", 1);
AddNumberParam("مبلغ", "مبلغ پرداخت به تومان");
AddStringParam("توضیحات", "توضیحات پرداخت");
AddStringParam("ایمیل", "ایمیل پرداخت کننده - اختیاری");
AddStringParam("تلفن", "تلفن پرداخت کننده - اختیاری");
AddAction(0, af_none, "پرداخت", "ZarinPal", "شروع عملیات پرداخت. شناسه پرداخت: {0} | نمایش خودکار: {1} | مبلغ: {2} | توضیحات: {3}", "شروع عملیات پرداخت", "StartPayment");
AddNumberParam("شناسه", "شناسه پرداخت");
AddAction(1, af_none, "نمایش صفحه پرداخت", "ZarinPal", "نمایش صفحه پرداخت. شناسه پرداخت: {0}", "نمایش صفحه پرداخت", "ShowPayment");


////////////////////////////////////////
// Expressions
AddExpression(0, ef_return_string, "RefId", "ZarinPal", "RefId", "شماره تراکنش");

ACESDone();

////////////////////////////////////////
// Properties
var property_list = [
	new cr.Property(ept_text, "Merchant ID", "", "Enter Your ZarinPal Merchant ID"),
	new cr.Property(ept_combo, "Sandbox", "Enable", "Test Payment", "Disable|Enable")
];

// Called by IDE when a new object type is to be created
function CreateIDEObjectType() {
    return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
    return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");

    // Save the constructor parameters
    this.instance = instance;
    this.type = type;

    // Set the default property values from the property table
    this.properties = {};

    for (var i = 0; i < property_list.length; i++)
        this.properties[property_list[i].name] = property_list[i].initial_value;

    // Plugin-specific variables
    // this.myValue = 0...
}

// Called when inserted via Insert Object Dialog for the first time
IDEInstance.prototype.OnInserted = function()
{
}

// Called when double clicked in layout
IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called after a property has been changed in the properties bar
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

// For rendered objects to load fonts or textures
IDEInstance.prototype.OnRendererInit = function(renderer)
{
}

// Called to draw self in the editor if a layout object
IDEInstance.prototype.Draw = function(renderer)
{
}

// For rendered objects to release fonts or textures
IDEInstance.prototype.OnRendererReleased = function(renderer)
{
}

