﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

cr.plugins_.Vinoos_ZarinPal = function(runtime)
{
	this.runtime = runtime;
};

(function () {

	var pluginProto = cr.plugins_.Vinoos_ZarinPal.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin) {
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function() {
		if(this.runtime.isBlackberry10 || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81){
			var scripts=document.getElementsByTagName("script");
			var scriptExist=false;
			for(var i=0;i<scripts.length;i++){
				//alert(scripts[i].src);//http://localhost:50000/jquery-2.0.0.min.js
				if(scripts[i].src.indexOf("cordova.js")!=-1||scripts[i].src.indexOf("phonegap.js")!=-1){
					scriptExist=true;
					break;
				}
			}
			if(!scriptExist){
				var newScriptTag=document.createElement("script");
				newScriptTag.setAttribute("type","text/javascript");
				newScriptTag.setAttribute("src", "cordova.js");
				document.getElementsByTagName("head")[0].appendChild(newScriptTag);
			}
		}
	};

	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;

	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	var refId = "";
	var id;
	
	// called whenever an instance is created
	instanceProto.onCreate = function() {

		if (!(this.runtime.isAndroid ))
			return;
        if (typeof window["ZarinPal"] == 'undefined')
            return;
		
		id = this;
		
		var sandbox = (this.properties[1]!=0?true:false);
		window["ZarinPal"]['initialize'](this.properties[0], sandbox, null);
		
		document.addEventListener("resume", onResume, false);
	};
	
	function onResume() {
		window["ZarinPal"]["verificationPayment"](PaymentResult, PaymentFailed);
	}
	
	function StartPaymentResult(result) {
		if (result.Status === 100) {
			id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onStartPaymentSuccess, id);
		} else {
			id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onStartPaymentFailed, id);
		}
	}
	
	function PaymentResult(result) {
		if (result.Success) {
			refId = result.RefID;
			id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onPaymentSuccess, id);
		} else {
			id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onPaymentFailed, id);
		}
	}
	
	function PaymentFailed(error) {
		id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onPaymentFailed, id);
	}
	
	function ShowPaymentFailed(error) {
		id.runtime.trigger(cr.plugins_.Vinoos_ZarinPal.prototype.cnds.onShowPaymentFailed, id);
	}
	
	instanceProto.draw = function(ctx){};
	instanceProto.drawGL = function (glw){};
	
	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	
	Cnds.prototype.onStartPaymentSuccess = function (tag) {
		return (this.tag === tag);
	};
	
	Cnds.prototype.onStartPaymentFailed = function (tag) {
		return (this.tag === tag);
	};
	
	Cnds.prototype.onPaymentSuccess = function (tag) {
		return (this.tag === tag);
	};
	
	Cnds.prototype.onPaymentFailed = function (tag) {
		return (this.tag === tag);
	};
	
	Cnds.prototype.onShowPaymentFailed = function (tag) {
		return (this.tag === tag);
	};
	
	pluginProto.cnds = new Cnds();
	
	//////////////////////////////////////
	// Actions
	function Acts() {};

	Acts.prototype.StartPayment = function (tag, autoStart, amount, description, email, phone) {
        if (!(this.runtime.isAndroid ))
            return;
        if (typeof window["ZarinPal"] == 'undefined')
            return;
		
		this.tag = tag;
        window["ZarinPal"]["startPayment"](autoStart!=0?true:false, amount, description, email, phone, StartPaymentResult);
	};

	Acts.prototype.ShowPayment = function (tag) {
        if (!(this.runtime.isAndroid ))
            return;
        if (typeof window["ZarinPal"] == 'undefined')
            return;
		
		this.tag = tag;
        window["ZarinPal"]["showPayment"](null, ShowPaymentFailed);
	};
	
	pluginProto.acts = new Acts();
	
	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
	Exps.prototype.RefId = function (ret) {
		ret.set_string(refId);
	};
	
	pluginProto.exps = new Exps();

}());